_A='siddhi'
import os
from typing import List
from localstack.packages import InstallTarget,Package,PackageInstaller
from localstack.packages.core import ArchiveDownloadAndExtractInstaller,DownloadInstaller
SIDDHI_SDK_URL='https://github.com/siddhi-io/siddhi-sdk/releases/download/v{version}/siddhi-sdk-{version}.zip'
SIDDHI_SDK_VERSION='5.1.2'
SIDDHI_PY_URL='https://github.com/siddhi-io/PySiddhi/releases/download/v{version}/siddhi-python-api-proxy-{version}.jar'
class SiddhiSdkPackage(Package):
	def __init__(A):super().__init__('SiddhiSdk',SIDDHI_SDK_VERSION)
	def get_versions(A):return[SIDDHI_SDK_VERSION]
	def _get_installer(A,version):return SiddhiSdkPackageInstaller('siddhi-sdk',version)
class SiddhiSdkPackageInstaller(ArchiveDownloadAndExtractInstaller):
	def _get_install_dir(A,target):return os.path.join(target.value,_A,A.version)
	def _get_install_marker_path(A,install_dir):return os.path.join(install_dir,A._get_archive_subdir())
	def _get_download_url(A):return SIDDHI_SDK_URL.format(version=A.version)
	def _get_archive_subdir(A):return f"siddhi-sdk-{A.version}"
class SiddhiPythonApiProxyPackage(Package):
	def __init__(A):super().__init__('SiddhiPythonApiProxy','5.1.0')
	def get_versions(A):return['5.1.0']
	def _get_installer(A,version):return SiddhiPythonApiProxyPackageInstaller('siddhi-python-api-proxy',version)
class SiddhiPythonApiProxyPackageInstaller(DownloadInstaller):
	def _get_install_dir(A,target):return os.path.join(target.value,_A,SIDDHI_SDK_VERSION,f"siddhi-sdk-{SIDDHI_SDK_VERSION}",'lib')
	def _get_download_url(A):return SIDDHI_PY_URL.format(version=A.version)
siddhi_sdk_package=SiddhiSdkPackage()
siddhi_python_api_proxy_package=SiddhiPythonApiProxyPackage()